#include<iostream>
#include<sstream>
#include<fstream>
#include<time.h>
#include"MySiTCP_CNTPIX.h"

#include"TH2.h"
#include"TCanvas.h"
#include"TStyle.h"
#include"TROOT.h"
#include"TApplication.h"

int main(int argc, char *argv[]){
  
  std::cout<<"This is a cntpix DAQ program."<<std::endl;

  // open parameter file  
  std::ifstream ifs("CNTPIX_Parameters.txt");

  // variables definition
  std::string tmp1,tmp2,IP;
  int TCP_Port, UDP_Port;
  int Counting_time,DAQ_interbal;
  int TEST_IN, window_mode, DAC_H, DAC_L;
  int VTHL, VTHH, TINV;
  int Max_1dwin,Max_1dy;
  int Max_2dcnt,Min_2dcnt=0;
  int total_rlen,rlen=0;
  int i=0,tempi,nofitr;
  float XLabels;

  // read parameters

  ifs>>tmp1>>IP;
  ifs>>tmp1>>TCP_Port;
  ifs>>tmp1>>UDP_Port;
  ifs>>tmp1;
  ifs>>tmp1>>TEST_IN;
  ifs>>tmp1>>window_mode;
  ifs>>tmp1>>DAC_H;
  ifs>>tmp1>>DAC_L;
  ifs>>tmp1;
  ifs>>tmp1;
  ifs>>tmp1>>VTHL>>tmp2;
  ifs>>tmp1>>VTHH>>tmp2;
  ifs>>tmp1>>TINV>>tmp2;
  ifs>>tmp1;
  ifs>>tmp1>>Counting_time>>tmp2;
  ifs>>tmp1>>DAQ_interbal>>tmp2;
  ifs>>tmp1>>Max_1dwin>>tmp2;
  ifs>>tmp1>>Max_2dcnt>>tmp2;
  ifs>>tmp1>>Min_2dcnt>>tmp2;
  ifs>>tmp1>> XLabels >> tmp2;
  ifs>>tmp1>> Max_1dy>>tmp2;

  std::cout << "TI=" << TEST_IN 
	    << "WM=" << window_mode << std::endl;
  std::cout << "DH=" << DAC_H << " DL=" << DAC_L << std::endl;
  std::cout << "VL=" << VTHL << " VH=" << VTHH << std::endl;
  std::cout << "TV=" << TINV << std::endl;
  std::cout << "CT=" << Counting_time 
	    <<" DI=" << DAQ_interbal << std::endl;
  std::cout << "1d=" << Max_1dwin <<std::endl;
  std::cout << "2d min " << Min_2dcnt 
	    <<" 2d max=" << Max_2dcnt << std::endl;
  std::cout << "1d_y " << Max_1dy << std::endl;

  MySiTCP_CNTPIX* sitcp = new MySiTCP_CNTPIX();
  sitcp->SetIPPort(IP.c_str(), TCP_Port, UDP_Port);
  sitcp->CreateTCPSock();
  sitcp->CreateUDPSock();
  
  std::cout << "start csr scan.." << std::endl;

  i=0;
  std::ifstream vtf("vth_parameters.txt");
  unsigned char csr = 0xff;
  // 0000_0000
  // default 0x20 = 32
  int cnt = 0;
  tempi = 0;
  // scan all pixel
  while(1){
    if(cnt==16384) break;
    vtf >> tempi;
    //        std::cout << window_mode << " " << TEST_IN 
    //        << " " << DAC_H << " " << tempi << " " << cnt << std::endl;
    sitcp->SetCSRIniValpix(window_mode, TEST_IN, DAC_H, tempi, cnt);
    rlen = recv(sitcp->GetTCPSock(), &csr, sizeof(csr), MSG_WAITALL);
    // std::cout << "csr= " << csr << " rlen=" 
    // << rlen << " cnt= " << cnt << std::endl;
    if(rlen < 0){
      perror("receive rlen < 0 ");
      return 1;
    }
    if(cnt%1024 == 0){
      //if(rlen>1){
      std::cout << cnt << " : receive success! -> \" " ;
      std::cout << (unsigned short)csr <<"\" length = "<<rlen<<" byte"<<std::endl;
    }
    cnt++;
  }
  vtf.close();
  
  TApplication tapp("tapplication",&argc,argv);
  
  if(Max_1dwin<=0){Max_1dwin=65536;}
  if(Max_2dcnt<=0){Max_2dcnt=5000;}
  if(Max_1dy<=0){Max_1dy=1000;}  

  TH1F* h1 = new TH1F("h1","count",100,0,Max_1dwin);
  TH2F* h2 = new TH2F("h2","image",128,0,128,128,0,128);
  //TH1F* h2 = new TH1F("h1","count",128,0,128);

  TCanvas *c1=new TCanvas("c1","canvas",1000,500);

  gStyle->SetOptStat("eMinoru");
  gStyle->SetPalette(1);
  h2->SetStats(0);
  h1->GetYaxis()->SetRangeUser(0,Max_1dy);
  h1->GetXaxis()->SetLabelSize(0.02);
  h2->GetZaxis()->SetRangeUser(Min_2dcnt,Max_2dcnt);
  h2->GetZaxis()->SetLabelSize(XLabels);
  //h2->GetYaxis()->SetRangeUser(0,20000);
  c1->Divide(2,1);
  c1->Draw();
  c1->Update();
  c1->SetLogy();
  fd_set fds, readfds;
  FD_ZERO(&readfds);
  FD_SET(sitcp->GetTCPSock(),&readfds);
  FD_SET(0, &readfds);

  unsigned short pixcnt[128][128];
  // 16384
  //  const int totalpix=128*128;
  //  unsigned short pixtemp[totalpix];
  int ii;

  struct tm *date;
  time_t now;
  time(&now);
  date = localtime(&now);
  std::string filename;
  std::ostringstream stream;
  stream<<"data/";
  if(date->tm_hour<10)stream<<"0";
  stream<<date->tm_hour;
  if(date->tm_min<10)stream<<"_0";
  else stream<<"_";
  stream<<date->tm_min;
  if(date->tm_sec<10)stream<<"_0";
  else stream<<"_";
  stream<<date->tm_sec;
  stream<<".dat";
  filename = stream.str();

  // write DAQ info 
  std::ofstream fs(filename.c_str());
  fs<<"Data taking date and time"<<std::endl;
  fs<< date->tm_mon+1 << "/" << date->tm_mday 
    <<","<<date->tm_year+1900<<std::endl;
  fs<<date->tm_hour<<":"<<date->tm_min<<":"
    <<date->tm_sec<<std::endl;
  fs<< std::endl;
  fs<< "Counting_time: "<<(double)Counting_time*40*16/1000000
    << " [ms]"<<std::endl;
  fs<< "Pixel_Scan_time: 240 [ns/pixel]"<<std::endl;
  fs<< "DAQ_Interbal: " 
    <<(double)DAQ_interbal*40/1000000
    <<" [ms]"<<std::endl;
  std::cout<<"Data acquisition every "
	   <<(double)((Counting_time*40*16+240*128)+DAQ_interbal*40)/1000000
	   <<"[ms]"<<std::endl;
  fs<<std::endl;

  sitcp->SetRAENHiTime(Counting_time);
  sitcp->SetDAQInterbal(DAQ_interbal);
  sitcp->DAC_cnt(0,VTHL);
  sitcp->DAC_cnt(1,VTHH);
  sitcp->DAC_cnt(2,TINV);

  std::cout<<"press Enter -> DAQ Start..."<<std::endl;
  char c;
  std::cin.get(c);
  sitcp->DAQStart(true);
  cnt = 0;
  while(1){
    cnt++;
    int rlen, jj, kk;
    // x4 512 ok ; 
    const int MAXCNT = 16384;
    unsigned short pixv1[1024];
    unsigned short pixvall[MAXCNT];
    if(cnt==1){
      for(ii=0;ii<MAXCNT;ii++){pixvall[ii]=0;}
      for(ii=0;ii<1024;ii++){pixv1[ii]=0;}
    }
    
    memcpy(&fds, &readfds, sizeof(fd_set));

    select(sitcp->GetTCPSock()+1, &fds, NULL, NULL, NULL);

    if(FD_ISSET(sitcp->GetTCPSock(),&fds)){
      total_rlen=0;
      nofitr=0;
      do{
	//MSG_WAITALL?
	rlen = recv(sitcp->GetTCPSock(), &pixv1, sizeof(pixv1),MSG_WAITALL);
	for(jj=total_rlen/2;jj<total_rlen/2+rlen/2;jj++){
	  pixvall[jj]=pixv1[jj-total_rlen/2]; 
	}
	total_rlen = total_rlen + rlen;
	nofitr++;
	//	std::cout << "Total_rlen=" 
	//	<< total_rlen << " rlen=" << rlen << std::endl;
      }while(total_rlen<MAXCNT*2);
      
      for(kk=0;kk<128;kk++){
	for(jj=0;jj<128;jj++){
	  pixcnt[kk][jj]=pixvall[kk*128+jj];
	}
      } 
      
      if(rlen < 0){
	perror("receive rlen<0");
	return 1;
      }
      
      h1->Reset();
      h2->Reset();
      
      std::cout << "--- event:"<< cnt << " # of ittration " << nofitr <<std::endl;      
      fs << "event:" << cnt <<std::endl;
      for(int i=0; i<128; i++){
	for(int j=0; j<128; j++){
	  if(pixcnt[i][j] > 0 && pixcnt[i][j]<65536){
	    h1->Fill(pixcnt[i][j]);
	    h2->Fill(j,127-i,pixcnt[i][j]);
	    //h2->Fill(i,pixcnt[i][j]);
	  }
	  fs<<pixcnt[i][j]<<" ";
	}
	fs<<std::endl;
      }
      c1->cd(1);
      //gPad->SetLogy(1);
      h1->Draw();
      c1->cd(2);
      h2->Draw("colz");
      //h2->Draw();
      c1->Modified();
      c1->Update();
      //  std::cout<<"event : "<<cnt<<std::endl;
      /*  for(int i=0; i<128; i++){
	  std::cout<<"RA : "<<i<<"\t = ";
	  for(int j=0; j<128; j++){
 	  std::cout<<pixcnt[i][j]<<" ";
	  }
	  std::cout<<std::endl;
	  }*/

    }else if(FD_ISSET(0, &fds)){
      break;
    }else{
      std::cout<<"error!! : select()"<<std::endl;
      exit(1);
    }
  }
  
  sitcp->DAQStart(false);
  
  fs.close();

  sitcp ->SetCSRIniValpix(0,0,0,0,0);
  //  rlen = recv(sitcp->GetTCPSock(), &csr, sizeof(csr), MSG_WAITALL);
  //  std::cout << "Receive at once : length " << rlen << std::endl;
  usleep(1000000);

  //  sitcp->SetCSRIniVal(0,0,0,0);
  //  sitcp->SetRAENHiTime(1000);
  //  sitcp->SetDAQInterbal(1000);
  //  sitcp->DAC_cnt(4,0);
  
  sitcp->CloseTCPSock();
  sitcp->CloseUDPSock();
  
  delete sitcp;
  tapp.Run();
  
  return 0;
}
